package com.alibaba.druid.sql.dialect.mysql.ast.statement;

import com.alibaba.druid.sql.ast.SQLExpr;
import com.alibaba.druid.sql.ast.SQLSubPartitionBy;
import com.alibaba.druid.sql.ast.statement.SQLColumnDefinition;
import com.alibaba.druid.sql.dialect.mysql.ast.MySqlObject;
import com.alibaba.druid.sql.dialect.mysql.visitor.MySqlASTVisitor;
import com.alibaba.druid.sql.visitor.SQLASTVisitor;
import java.util.ArrayList;
import java.util.List;

public class MySqlSubPartitionByList extends SQLSubPartitionBy implements MySqlObject {
   private List<SQLExpr> keys = new ArrayList();
   private List<SQLColumnDefinition> columns = new ArrayList();

   protected void accept0(SQLASTVisitor visitor) {
      if (visitor instanceof MySqlASTVisitor) {
         this.accept0((MySqlASTVisitor)visitor);
      } else {
         throw new IllegalArgumentException("not support visitor type : " + visitor.getClass().getName());
      }
   }

   public void accept0(MySqlASTVisitor visitor) {
      if (visitor.visit(this)) {
         this.acceptChild(visitor, this.keys);
         this.acceptChild(visitor, this.columns);
         this.acceptChild(visitor, this.subPartitionsCount);
      }

      visitor.endVisit(this);
   }

   public List<SQLExpr> getKeys() {
      return this.keys;
   }

   public void addKey(SQLExpr key) {
      if (key != null) {
         key.setParent(this);
      }

      this.keys.add(key);
   }

   public List<SQLColumnDefinition> getColumns() {
      return this.columns;
   }

   public void addColumn(SQLColumnDefinition column) {
      if (column != null) {
         column.setParent(this);
      }

      this.columns.add(column);
   }

   public void cloneTo(MySqlSubPartitionByList x) {
      super.cloneTo(x);

      for(SQLExpr key : this.keys) {
         SQLExpr k2 = key.clone();
         k2.setParent(x);
         x.keys.add(k2);
      }

      for(SQLColumnDefinition column : this.columns) {
         SQLColumnDefinition c2 = column.clone();
         c2.setParent(x);
         x.columns.add(c2);
      }

   }

   public MySqlSubPartitionByList clone() {
      MySqlSubPartitionByList x = new MySqlSubPartitionByList();
      this.cloneTo(x);
      return x;
   }
}
